<template>
    <div class="machine">
        <div class="lights">
            <div class="light"></div>
            <div class="light lg text-lg">{{ credits }}</div>
            <div class="light"></div>
        </div>
        <div class="slots">
            <div class="slot">
                <img :src="slots[0]" alt="" id="slot0" />
            </div>
            <div class="slot">
                <img :src="slots[1]" alt="" id="slot1" />
            </div>
            <div class="slot">
                <img :src="slots[2]" alt="" id="slot2" />
            </div>
        </div>
        <div class="lights">
            <div class="light lg" id="cashout" @mouseover="sabotage">CASH<br />OUT</div>
            <div
                class="light lg"
                @click="roll"
                :class="[!rollAllowed || credits < 1 ? 'disabled' : '']"
            >
                ROLL
            </div>
            <div class="light lg" @click="reset">RESET</div>
        </div>
    </div>
</template>
<script lang="ts">
import { defineComponent } from "vue";
export default defineComponent({
    created() {
        document.title = "Slot Machine";
    },
    data() {
        return {
            credits: 10,
            rollAllowed: true,
            slots: ["question.svg", "question.svg", "question.svg"],
            symbols: ["cherry.svg", "lemon.svg", "orange.svg", "watermelon.svg"],
        };
    },
    methods: {
        //Sabotaging The Cashout Button
        sabotage() {
            const el = document.querySelector("#cashout") as HTMLElement;
            const chance = Math.random();
            const direction = Math.floor(Math.random() * 4);
            if (chance < 0.5) {
                switch (direction) {
                    case 0:
                        el.style.transform = "translateX(300px)";
                        break;
                    case 1:
                        el.style.transform = "translateX(-300px)";
                        break;
                    case 2:
                        el.style.transform = "translateY(-300px)";
                        break;
                    case 3:
                        el.style.transform = "translateY(300px)";
                        break;
                }
            }
            if (chance < 0.4) {
                el?.classList.add("disabled");
            }
        },
        //Resetting App To Initial State
        reset() {
            this.slots = ["question.svg", "question.svg", "question.svg"];
            this.credits = 10;
        },
        //Toggle Spininng Animation
        toggleAnimation(toggle: Boolean, id: string) {
            const el = document.querySelector(id);
            if (toggle) {
                el?.classList.add("spin-anim");
            } else {
                el?.classList.remove("spin-anim");
            }
        },
        //Update Credits By Number
        updateCredit(n: number) {
            this.credits += n;
        },
        //Generate Truly Random Collection
        generateRandomCollection() {
            const result = [];
            for (let i = 0; i < 3; i++) {
                result.push(this.symbols[Math.floor(Math.random() * this.symbols.length)]);
            }
            return result;
        },
        //Deciding Win
        isWinner(result: Array<any>) {
            return result[0] === result[1] && result[1] === result[2];
        },
        //Initializing Roll And Starting The Animations
        initRoll(index: number) {
            return setInterval(() => {
                this.toggleAnimation(true, "#slot" + index);
                this.slots[index] = this.symbols[Math.floor(Math.random() * this.symbols.length)];
            }, 250);
        },
        //Stopping Roll And Resetting The Animations
        stopRoll(index: number, interval: any, result: Array<any>) {
            setTimeout(() => {
                clearInterval(interval);
                this.toggleAnimation(false, "#slot" + index);
                this.slots[index] = result[index];
            }, (index + 1) * 1000);
        },
        //Deciding Credits Based On Symbols And Win
        decideCredits(winner: boolean) {
            if (winner) {
                if (this.slots[0] === "cherry.svg") {
                    this.updateCredit(10);
                } else if (this.slots[0] === "lemon.svg") {
                    this.updateCredit(20);
                } else if (this.slots[0] === "orange.svg") {
                    this.updateCredit(30);
                } else if (this.slots[0] === "watermelon.svg") {
                    this.updateCredit(40);
                }
            } else {
                this.updateCredit(-1);
            }
            this.rollAllowed = true;
        },
        //Bussiness Logic
        roll() {
            //Checking If Roll Is Allowed
            if (!this.rollAllowed || this.credits < 1) return 0;
            //Disabling Roll When Spininng
            this.rollAllowed = false;
            //Starting Roll
            const slot0Spinner = this.initRoll(0);
            const slot1Spinner = this.initRoll(1);
            const slot2Spinner = this.initRoll(2);
            //Generating Roll
            var result = this.generateRandomCollection();
            var winner = this.isWinner(result);
            //Sabotaging High Credit Users
            if (winner) {
                const chance = Math.random();
                if (this.credits >= 40 && this.credits <= 60 && chance < 0.3) {
                    result = this.generateRandomCollection();
                    winner = this.isWinner(result);
                } else if (this.credits > 60 && chance < 0.6) {
                    result = this.generateRandomCollection();
                    winner = this.isWinner(result);
                }
            }
            //Stopping Roll
            this.stopRoll(0, slot0Spinner, result);
            this.stopRoll(1, slot1Spinner, result);
            this.stopRoll(2, slot2Spinner, result);
            //Updating Credits
            setTimeout(() => this.decideCredits(winner), 3000);
        },
    },
});
</script>
<style lang="scss" scoped>
.machine {
    background: #ffba08;
    height: 85vh;
    border-radius: 10px;
    width: 60vw;
    gap: 50px;
    padding: 20px 20px;
    display: flex;
    flex-direction: column;
    justify-content: center;
    .lights {
        display: flex;
        justify-content: center;
        align-items: center;
        gap: 50px;
        .light {
            display: flex;
            color: #ffba08;
            font-weight: 900;
            font-size: 1.5rem;
            cursor: pointer;
            text-align: center;
            justify-content: center;
            align-items: center;
            background: #9c0000;
            width: clamp(30px, 5vw, 200px);
            height: clamp(30px, 5vw, 200px);
            aspect-ratio: 1;
            border-radius: 50%;
            transition: all 0.2s ease-in-out;
        }
        .light:hover {
            box-shadow: 0px 10px 0px #000;
        }
        .lg {
            width: clamp(50px, 7vw, 200px);
            height: clamp(50px, 7vw, 200px);
        }
        .text-lg {
            font-size: 2rem;
        }
    }
    .slots {
        display: grid;
        grid-template-columns: repeat(3, 1fr);
        justify-items: center;
        .slot {
            overflow: hidden;
            width: clamp(50px, 15vw, 200px);
            aspect-ratio: 1;
            background-color: #eee;
            border: 1px solid #000;
            border-radius: 5px;
            display: flex;
            justify-content: center;
            img {
                margin: 15px;
            }
        }
    }
    .invisible {
        visibility: hidden;
    }
    .disabled {
        opacity: 0.7;
    }
    .roll {
        width: clamp(50px, 100%, 200px);
        aspect-ratio: 1;
        border-radius: 5px;
        display: flex;
        justify-content: center;
        align-items: center;
        font-weight: 900;
        font-size: 1.5rem;
        text-transform: uppercase;
        cursor: pointer;
    }
    .spin-anim {
        animation: spin 0.5s infinite linear;
    }
    @keyframes spin {
        0% {
            transform: translateY(-200px);
            width: 50px;
        }
        50% {
            transform: translateY(0);
            width: clamp(50px, 15vw, 200px);
        }
        100% {
            transform: translateY(200px);
            width: 50px;
        }
    }
}
@media only screen and (max-width: 1200px) {
    .light {
        font-size: 1rem !important;
    }
}

@media only screen and (max-width: 900px) {
    .light {
        font-size: 0.8rem !important;
    }
}
</style>
